import Vue from 'vue'

// import m from './mutation-types'
import m from './mutation-types'

export default {
  [m.REGISTRY_UPDATE] (state, registry) {
    state.registry = registry
  },
  [m.DOCUMENT_UPDATE] (state, nodeData) {
    state.nodeData = nodeData
  },
  [m.ACTIVITY_UPDATE] (state, activity) {
    state.activity = activity
  },
  [m.NODE_RAISE] (state, nodes) {
    for (let k in nodes) {
      let ni = state.nodeData.nodes.findIndex(n => n.id === nodes[k].id)
      const node = state.nodeData.nodes[ni]
      state.nodeData.nodes.splice(ni, 1)
      state.nodeData.nodes.push(node) // put in last
    }
  },
  [m.NODE_UPDATE] (state, nodes) {
    // If array
    for (let k in nodes) {
      const node = nodes[k]
      const ni = state.nodeData.nodes.findIndex(n => n.id === node.id)
      Vue.set(state.nodeData.nodes, ni, node)
      if (node.id === state.nodeInspect.id) {
        state.nodeInspect = node
      }
    }
  },
  [m.NODE_ADD] (state, node) {
    state.nodeData.nodes.push(node)
  },
  [m.NODE_REMOVE] (state, nodes) {
    for (let k in nodes) {
      const node = nodes[k]
      const ni = state.nodeData.nodes.findIndex(n => n.id === node.id)
      state.nodeData.links = state.nodeData.links
        .filter(l => l.from !== node.id && l.to !== node.id)
      state.nodeData.triggers = state.nodeData.triggers
        .filter(l => l.from !== node.id && l.to !== node.id)
      state.nodeData.nodes.splice(ni, 1)
    }
  },
  [m.NODE_INSPECT] (state, nodeId) {
    const node = state.nodeData.nodes.find(n => n.id === nodeId)
    state.nodeInspect = node
  },
  [m.LINK_ADD] (state, link) {
    state.nodeData.links.push(link)
  },
  [m.LINK_REMOVE] (state, link) {
    const i = state.nodeData.links.findIndex(l => l === link)
    if (i === -1) return
    state.nodeData.links.splice(i, 1)
  },

  [m.TRIGGER_ADD] (state, trigger) {
    state.nodeData.triggers.push(trigger)
  },
  [m.TRIGGER_REMOVE] (state, trigger) {
    const i = state.nodeData.triggers.findIndex(l => l === trigger)
    if (i === -1) return
    state.nodeData.triggers.splice(i, 1)
  }
}
