import defRegistry from './default-registry'
import m from './mutation-types'
import flowService from '@/services/flowservice'

export default store => {
  store.subscribe(mut => {
    // console.log('I changed -- perform the connection somehow', mut)
  })

  flowService.on('document', (v) => {
    store.commit(m.DOCUMENT_UPDATE, v.data)
  })
  flowService.on('nodeUpdate', (v) => {
    store.commit(m.NODE_UPDATE, v.data)
  })

  flowService.on('registry', (v) => {
    let res = {}
    for (let k of Object.keys(v.data)) {
      const e = v.data[k]
      res[k] = {
        categories: e.categories,
        inputs: e.inputs,
        inputDesc: e.inputDesc,

        output: e.output,
        outputDesC: e.outputDesc,
        style: e.extra && e.extra.style
      }
    }
    store.commit(m.REGISTRY_UPDATE, Object.assign({}, defRegistry, res))
  })
  flowService.on('nodeActivity', (v) => {
    store.commit(m.ACTIVITY_UPDATE, v.data || {})
  })
}
